summaryrefslogtreecommitdiff
path: root/contrib/ffmpeg/configure
diff options
context:
space:
mode:
authorDiego 'Flameeyes' Pettenò <flameeyes@gmail.com>2006-12-02 01:19:48 +0000
committerDiego 'Flameeyes' Pettenò <flameeyes@gmail.com>2006-12-02 01:19:48 +0000
commit0ea721f7ce81357bc4ec6eea609cd50482c3d15b (patch)
tree25a0871cb3c06f9716acf9c204192d548f214048 /contrib/ffmpeg/configure
parentd8ec380876e7f697ba609546d61757ab3f2d8715 (diff)
downloadxine-lib-0ea721f7ce81357bc4ec6eea609cd50482c3d15b.tar.gz
xine-lib-0ea721f7ce81357bc4ec6eea609cd50482c3d15b.tar.bz2
Start working on a branch where FFmpeg is not copied, patched and carved to be built with automake but instead imported inline and built using its own build system. This is an import of a slightly modified FFmpeg current tree. xine-lib builds, install and run fine with it, but there are of course plenty of things that needs to be fixed before it can even be considered for a 1.2.x series. Work will continue in the next days of course.
CVS patchset: 8397 CVS date: 2006/12/02 01:19:48
Diffstat (limited to 'contrib/ffmpeg/configure')
-rwxr-xr-xcontrib/ffmpeg/configure2186
1 files changed, 2186 insertions, 0 deletions
diff --git a/contrib/ffmpeg/configure b/contrib/ffmpeg/configure
new file mode 100755
index 000000000..8da8f0916
--- /dev/null
+++ b/contrib/ffmpeg/configure
@@ -0,0 +1,2186 @@
+#!/bin/sh
+#
+# FFmpeg configure script
+#
+# Copyright (c) 2000, 2001, 2002 Fabrice Bellard
+# Copyright (c) 2005-2006 Diego Biurrun
+# Copyright (c) 2005-2006 Mans Rullgard
+#
+
+# make sure we are running under a compatible shell
+# try to make this part work with most shells
+
+try_exec(){
+ type "$1" >/dev/null 2>&1 && exec "$@"
+}
+
+unset foo
+(: ${foo%%bar}) 2>/dev/null && ! (: ${foo?}) 2>/dev/null
+if test "$?" != 0; then
+ export FF_CONF_EXEC
+ if test "0$FF_CONF_EXEC" -lt 1; then
+ FF_CONF_EXEC=1
+ try_exec bash "$0" "$@"
+ fi
+ if test "0$FF_CONF_EXEC" -lt 2; then
+ FF_CONF_EXEC=2
+ try_exec ksh "$0" "$@"
+ fi
+ if test "0$FF_CONF_EXEC" -lt 3; then
+ FF_CONF_EXEC=3
+ try_exec /usr/xpg4/bin/sh "$0" "$@"
+ fi
+ echo "No compatible shell script interpreter found."
+ echo "This configure script requires a POSIX compatible shell"
+ echo "such as bash or ksh."
+ if test "$BASH_VERSION" = '2.04.0(1)-release'; then
+ echo "This bash version ($BASH_VERSION) is broken on your platform."
+ echo "Upgrade to a later version if available."
+ fi
+ exit 1
+fi
+
+show_help(){
+ echo "Usage: configure [options]"
+ echo "Options: [defaults in brackets after descriptions]"
+ echo
+ echo "Standard options:"
+ echo " --help print this message"
+ echo " --log[=FILE|yes|no] log tests and output to FILE [config.err]"
+ echo " --prefix=PREFIX install in PREFIX [$PREFIX]"
+ echo " --libdir=DIR install libs in DIR [PREFIX/lib]"
+ echo " --shlibdir=DIR install shared libs in DIR [PREFIX/lib]"
+ echo " --incdir=DIR install includes in DIR [PREFIX/include/ffmpeg]"
+ echo " --mandir=DIR install man page in DIR [PREFIX/man]"
+ echo " --enable-mp3lame enable MP3 encoding via libmp3lame [default=no]"
+ echo " --enable-libnut enable NUT support via libnut [default=no]"
+ echo " --enable-libogg enable Ogg support via libogg [default=no]"
+ echo " --enable-vorbis enable Vorbis support via libvorbis [default=no]"
+ echo " --enable-faad enable FAAD support via libfaad [default=no]"
+ echo " --enable-faadbin build FAAD support with runtime linking [default=no]"
+ echo " --enable-faac enable FAAC support via libfaac [default=no]"
+ echo " --enable-libgsm enable GSM support via libgsm [default=no]"
+ echo " --enable-xvid enable XviD support via xvidcore [default=no]"
+ echo " --enable-x264 enable H.264 encoding via x264 [default=no]"
+ echo " --enable-mingw32 enable MinGW native/cross Windows compile"
+ echo " --enable-mingwce enable MinGW native/cross WinCE compile"
+ echo " --enable-a52 enable GPLed A52 support [default=no]"
+ echo " --enable-a52bin open liba52.so.0 at runtime [default=no]"
+ echo " --enable-dts enable GPLed DTS support [default=no]"
+ echo " --enable-pp enable GPLed postprocessing support [default=no]"
+ echo " --enable-static build static libraries [default=yes]"
+ echo " --disable-static do not build static libraries [default=no]"
+ echo " --enable-shared build shared libraries [default=no]"
+ echo " --disable-shared do not build shared libraries [default=yes]"
+ echo " --enable-amr_nb enable amr_nb float audio codec"
+ echo " --enable-amr_nb-fixed use fixed point for amr-nb codec"
+ echo " --enable-amr_wb enable amr_wb float audio codec"
+ echo " --enable-amr_if2 enable amr_wb IF2 audio codec"
+ echo " --enable-sunmlib use Sun medialib [default=no]"
+ echo " --enable-pthreads use pthreads [default=no]"
+ echo " --enable-dc1394 enable IIDC-1394 grabbing using libdc1394"
+ echo " and libraw1394 [default=no]"
+ echo " --enable-swscaler software scaler support [default=no]"
+ echo " --enable-avisynth allow reading AVISynth script files [default=no]"
+ echo " --enable-gpl allow use of GPL code, the resulting libav*"
+ echo " and ffmpeg will be under GPL [default=no]"
+ echo ""
+ echo "Advanced options (experts only):"
+ echo " --source-path=PATH path to source code [$source_path]"
+ echo " --build-path=PATH path to build directory [.]"
+ echo " --cross-prefix=PREFIX use PREFIX for compilation tools [$cross_prefix]"
+ echo " --cross-compile assume a cross-compiler is used"
+ echo " --cc=CC use C compiler CC [$cc]"
+ echo " --make=MAKE use specified make [$make]"
+ echo " --extra-cflags=ECFLAGS add ECFLAGS to CFLAGS [$CFLAGS]"
+ echo " --extra-ldflags=ELDFLAGS add ELDFLAGS to LDFLAGS [$LDFLAGS]"
+ echo " --extra-libs=ELIBS add ELIBS [$ELIBS]"
+ echo " --build-suffix=SUFFIX suffix for application specific build []"
+ echo " --arch=ARCH select architecture [$arch]"
+ echo " --cpu=CPU selects the minimum cpu required (affects
+ instruction selection, may crash on older CPUs)"
+ echo " --powerpc-perf-enable enable performance report on PPC"
+ echo " (requires enabling PMC)"
+ echo " --disable-mmx disable MMX usage"
+ echo " --disable-armv5te disable armv5te usage"
+ echo " --disable-iwmmxt disable iwmmxt usage"
+ echo " --disable-altivec disable AltiVec usage"
+ echo " --disable-audio-oss disable OSS audio support [default=no]"
+ echo " --disable-audio-beos disable BeOS audio support [default=no]"
+ echo " --disable-v4l disable video4linux grabbing [default=no]"
+ echo " --disable-v4l2 disable video4linux2 grabbing [default=no]"
+ echo " --disable-bktr disable bktr video grabbing [default=no]"
+ echo " --disable-dv1394 disable DV1394 grabbing [default=no]"
+ echo " --disable-network disable network support [default=no]"
+ echo " --disable-ipv6 disable ipv6 support [default=no]"
+ echo " --disable-zlib disable zlib [default=no]"
+ echo " --disable-vhook disable video hooking support"
+ echo " --enable-gprof enable profiling with gprof [$gprof]"
+ echo " --disable-debug disable debugging symbols"
+ echo " --disable-opts disable compiler optimizations"
+ echo " --enable-extra-warnings enable more compiler warnings"
+ echo " --disable-mpegaudio-hp faster (but less accurate)"
+ echo " MPEG audio decoding [default=no]"
+ echo " --disable-protocols disable I/O protocols support [default=no]"
+ echo " --disable-ffmpeg disable ffmpeg build"
+ echo " --disable-ffserver disable ffserver build"
+ echo " --disable-ffplay disable ffplay build"
+ echo " --enable-small optimize for size instead of speed"
+ echo " --enable-memalign-hack emulate memalign, interferes with memory debuggers"
+ echo " --disable-strip disable stripping of executables and shared libraries"
+ echo " --disable-encoder=NAME disables encoder NAME"
+ echo " --enable-encoder=NAME enables encoder NAME"
+ echo " --disable-decoder=NAME disables decoder NAME"
+ echo " --enable-decoder=NAME enables decoder NAME"
+ echo " --disable-encoders disables all encoders"
+ echo " --disable-decoders disables all decoders"
+ echo " --disable-muxer=NAME disables muxer NAME"
+ echo " --enable-muxer=NAME enables muxer NAME"
+ echo " --disable-muxers disables all muxers"
+ echo " --disable-demuxer=NAME disables demuxer NAME"
+ echo " --enable-demuxer=NAME enables demuxer NAME"
+ echo " --disable-demuxers disables all demuxers"
+ echo " --enable-parser=NAME enables parser NAME"
+ echo " --disable-parser=NAME disables parser NAME"
+ echo " --disable-parsers disables all parsers"
+ echo ""
+ echo "NOTE: Object files are built at the place where configure is launched."
+ exit 1
+}
+
+log(){
+ echo "$@" >>$logfile
+}
+
+log_file(){
+ log BEGIN $1
+ cat -n $1 >>$logfile
+ log END $1
+}
+
+echolog(){
+ log "$@"
+ echo "$@"
+}
+
+die(){
+ echolog "$@"
+ cat <<EOF
+If you think configure made a mistake, make sure you are using the latest
+version from SVN. If the latest version fails, report the problem to the
+ffmpeg-devel@mplayerhq.hu mailing list or IRC #ffmpeg on irc.freenode.net.
+EOF
+ if enabled logging; then
+ cat <<EOF
+Include the log file "$logfile" produced by configure as this will help
+solving the problem.
+EOF
+ else
+cat <<EOF
+Rerun configure with logging enabled (do not use --log=no), and include the
+log this produces with your report.
+EOF
+ fi
+ rm -f $TMPC $TMPO $TMPE $TMPS $TMPH
+ exit 1
+}
+
+# "tr '[a-z]' '[A-Z]'" is a workaround for Solaris tr not grokking "tr a-z A-Z"
+toupper(){
+ echo "$@" | tr '[a-z]' '[A-Z]'
+}
+
+set_all(){
+ value=$1
+ shift
+ for var in $*; do
+ eval $var=$value
+ done
+}
+
+enable(){
+ set_all yes $*
+}
+
+disable(){
+ set_all no $*
+}
+
+enabled(){
+ eval test "x\$$1" = "xyes"
+}
+
+enabled_all(){
+ for opt; do
+ enabled $opt || return 1
+ done
+}
+
+enabled_any(){
+ for opt; do
+ enabled $opt && return 0
+ done
+}
+
+print_config(){
+ pfx=$1
+ header=$2
+ makefile=$3
+ shift 3
+ for cfg; do
+ if enabled $cfg; then
+ ucname="${pfx}`toupper $cfg`"
+ echo "#define ${ucname} 1" >> $header
+ echo "${ucname}=yes" >> $makefile
+ fi
+ done
+}
+
+flags_saved(){
+ (: ${SAVE_CFLAGS?}) 2>/dev/null
+}
+
+save_flags(){
+ flags_saved && return
+ SAVE_CFLAGS="$CFLAGS"
+ SAVE_LDFLAGS="$LDFLAGS"
+ SAVE_extralibs="$extralibs"
+}
+
+restore_flags(){
+ CFLAGS="$SAVE_CFLAGS"
+ LDFLAGS="$SAVE_LDFLAGS"
+ extralibs="$SAVE_extralibs"
+ unset SAVE_CFLAGS
+ unset SAVE_LDFLAGS
+ unset SAVE_extralibs
+}
+
+temp_cflags(){
+ save_flags
+ CFLAGS="$CFLAGS $*"
+}
+
+temp_ldflags(){
+ save_flags
+ LDFLAGS="$LDFLAGS $*"
+}
+
+temp_extralibs(){
+ save_flags
+ extralibs="$extralibs $*"
+}
+
+append(){
+ var=$1
+ shift
+ flags_saved && eval "SAVE_$var=\"\$SAVE_$var $*\""
+ eval "$var=\"\$$var $*\""
+}
+
+add_cflags(){
+ append CFLAGS "$@"
+}
+
+add_ldflags(){
+ append LDFLAGS "$@"
+}
+
+add_extralibs(){
+ append extralibs "$@"
+}
+
+check_cmd(){
+ log "$@"
+ "$@" >>$logfile 2>&1
+}
+
+check_cc(){
+ log check_cc "$@"
+ cat >$TMPC
+ log_file $TMPC
+ check_cmd $cc $CFLAGS "$@" -c -o $TMPO $TMPC
+}
+
+check_cpp(){
+ log check_cpp "$@"
+ cat >$TMPC
+ log_file $TMPC
+ check_cmd $cc $CFLAGS "$@" -E -o $TMPO $TMPC
+}
+
+check_ld(){
+ log check_ld "$@"
+ check_cc || return
+ check_cmd $cc $LDFLAGS "$@" -o $TMPE $TMPO $extralibs
+}
+
+check_cflags(){
+ log check_cflags "$@"
+ check_cc "$@" <<EOF && add_cflags "$@"
+int x;
+EOF
+}
+
+check_ldflags(){
+ log check_ldflags "$@"
+ check_ld "$@" <<EOF && add_ldflags "$@"
+int main(){
+ return 0;
+}
+EOF
+}
+
+check_header(){
+ log check_header "$@"
+ header=$1
+ shift
+ check_cpp "$@" <<EOF
+#include <$header>
+int x;
+EOF
+ err=$?
+ var=`echo $header | sed 's/[^[:alnum:]]/_/g'`
+ test "$err" = 0 && enable $var || disable $var
+ return $err
+}
+
+check_func(){
+ log check_func "$@"
+ func=$1
+ shift
+ check_ld "$@" <<EOF
+extern int $func();
+int main(){
+ $func();
+}
+EOF
+ err=$?
+ test "$err" = 0 && enable $func || disable $func
+ return $err
+}
+
+check_lib(){
+ log check_lib "$@"
+ header="$1"
+ func="$2"
+ shift 2
+ temp_extralibs "$@"
+ check_header $header && check_func $func && add_extralibs "$@"
+ err=$?
+ restore_flags
+ return $err
+}
+
+check_exec(){
+ check_ld "$@" && { test "$cross_compile" = yes || $TMPE >>$logfile 2>&1; }
+}
+
+require(){
+ name="$1"
+ header="$2"
+ func="$3"
+ shift 3
+ check_lib $header $func "$@" || die "ERROR: $name not found"
+}
+
+CONFIG_LIST='
+ encoders
+ decoders
+ parsers
+ muxers
+ demuxers
+ a52
+ a52bin
+ amr
+ amr_nb
+ amr_nb_fixed
+ amr_wb
+ audio_beos
+ audio_oss
+ avisynth
+ beos_netserver
+ bktr
+ dc1394
+ dts
+ dv1394
+ faac
+ faad
+ faadbin
+ ffmpeg
+ ffplay
+ ffserver
+ gpl
+ ipv6
+ libgsm
+ libnut
+ libogg
+ libvorbis
+ memalign_hack
+ mp3lame
+ mpegaudio_hp
+ network
+ pp
+ protocols
+ swscaler
+ vhook
+ video4linux
+ video4linux2
+ wince
+ x264
+ xvid
+ zlib
+'
+
+HAVE_LIST='
+ altivec_h
+ beosthreads
+ byteswap_h
+ dcbzl
+ dlfcn_h
+ dlopen
+ freetype2
+ gprof
+ imlib2
+ inet_aton
+ localtime_r
+ lrintf
+ malloc_h
+ memalign
+ mlib
+ os2
+ os2threads
+ pthreads
+ sdl
+ sdl_video_size
+ threads
+ w32threads
+'
+
+# set temporary file name
+if test ! -z "$TMPDIR" ; then
+ TMPDIR1="${TMPDIR}"
+elif test ! -z "$TEMPDIR" ; then
+ TMPDIR1="${TEMPDIR}"
+else
+ TMPDIR1="/tmp"
+fi
+
+TMPC="${TMPDIR1}/ffmpeg-conf-${RANDOM}-$$-${RANDOM}.c"
+TMPO="${TMPDIR1}/ffmpeg-conf-${RANDOM}-$$-${RANDOM}.o"
+TMPE="${TMPDIR1}/ffmpeg-conf-${RANDOM}-$$-${RANDOM}"
+TMPS="${TMPDIR1}/ffmpeg-conf-${RANDOM}-$$-${RANDOM}.S"
+TMPH="${TMPDIR1}/ffmpeg-conf-${RANDOM}-$$-${RANDOM}.h"
+
+# default parameters
+logging="yes"
+logfile="config.err"
+PREFIX="/usr/local"
+libdir='${PREFIX}/lib'
+shlibdir="$libdir"
+incdir='${PREFIX}/include/ffmpeg'
+mandir='${PREFIX}/man'
+bindir='${PREFIX}/bin'
+cross_prefix=""
+cross_compile="no"
+cc="gcc"
+ar="ar"
+ranlib="ranlib"
+make="make"
+strip="strip"
+arch=`uname -m`
+cpu="generic"
+powerpc_perf="no"
+mmx="default"
+cmov="no"
+cmov_is_fast="no"
+armv5te="default"
+iwmmxt="default"
+altivec="default"
+dcbzl="no"
+mmi="default"
+case "$arch" in
+ i386|i486|i586|i686|i86pc|BePC)
+ arch="x86_32"
+ ;;
+ x86_64|amd64)
+ arch="x86_32"
+ canon_arch="`$cc -dumpmachine | sed -e 's,\([^-]*\)-.*,\1,'`"
+ if [ x"$canon_arch" = x"x86_64" -o x"$canon_arch" = x"amd64" ]; then
+ if [ -z "`echo $CFLAGS | grep -- -m32`" ]; then
+ arch="x86_64"
+ fi
+ fi
+ ;;
+ # armv4l is a subset of armv[567]*l
+ arm|armv[4567]*l)
+ arch="armv4l"
+ ;;
+ alpha)
+ arch="alpha"
+ ;;
+ "Power Macintosh"|ppc|ppc64|powerpc)
+ arch="powerpc"
+ ;;
+ mips|mipsel|IP*)
+ arch="mips"
+ ;;
+ sun4u|sparc64)
+ arch="sparc64"
+ ;;
+ sparc)
+ arch="sparc"
+ ;;
+ sh4)
+ arch="sh4"
+ ;;
+ parisc|parisc64)
+ arch="parisc"
+ ;;
+ s390|s390x)
+ arch="s390"
+ ;;
+ m68k)
+ arch="m68k"
+ ;;
+ ia64)
+ arch="ia64"
+ ;;
+ bfin)
+ arch="bfin"
+ ;;
+ *)
+ arch="unknown"
+ ;;
+esac
+gprof="no"
+video4linux="yes"
+video4linux2="yes"
+bktr="no"
+audio_oss="yes"
+audio_beos="no"
+dv1394="yes"
+dc1394="no"
+network="yes"
+ipv6="yes"
+zlib="yes"
+libgsm="no"
+mp3lame="no"
+libnut="no"
+libogg="no"
+libvorbis="no"
+faad="no"
+faadbin="no"
+faac="no"
+xvid="no"
+x264="no"
+a52="no"
+a52bin="no"
+dts="no"
+pp="no"
+mingw32="no"
+wince="no"
+os2="no"
+lstatic="yes"
+lshared="no"
+optimize="yes"
+debug="yes"
+extrawarnings="no"
+dostrip="yes"
+installstrip="-s"
+extralibs="-lm"
+bigendian="no"
+vhook="default"
+avisynth="no"
+dlfcn_h="no"
+dlopen="no"
+mpegaudio_hp="yes"
+SHFLAGS='-shared -Wl,-soname,$@'
+VHOOKSHFLAGS='$(SHFLAGS)'
+beos_netserver="no"
+protocols="yes"
+ffmpeg="yes"
+ffserver="yes"
+ffplay="yes"
+LIBOBJFLAGS=""
+FFLDFLAGS=-Wl,--warn-common
+LDLATEFLAGS='-Wl,-rpath-link,\$(BUILD_ROOT)/libavcodec -Wl,-rpath-link,\$(BUILD_ROOT)/libavformat -Wl,-rpath-link,\$(BUILD_ROOT)/libavutil'
+FFSERVERLDFLAGS=-Wl,-E
+LDCONFIG="ldconfig"
+LIBPREF="lib"
+LIBSUF=".a"
+LIB='$(LIBPREF)$(NAME)$(LIBSUF)'
+SLIBPREF="lib"
+SLIBSUF=".so"
+SLIBNAME='$(SLIBPREF)$(NAME)$(SLIBSUF)'
+SLIBNAME_WITH_VERSION='$(SLIBNAME).$(LIBVERSION)'
+SLIBNAME_WITH_MAJOR='$(SLIBNAME).$(LIBMAJOR)'
+EXESUF=""
+BUILDSUF=""
+amr_nb="no"
+amr_wb="no"
+amr_nb_fixed="no"
+amr_if2="no"
+mlib="no"
+pthreads="no"
+swscaler="no"
+gpl="no"
+memalign_hack="no"
+asmalign_pot="unknown"
+LIB_INSTALL_EXTRA_CMD='$(RANLIB) "$(libdir)/$(LIB)"'
+
+# OS specific
+targetos=`uname -s`
+case $targetos in
+BeOS)
+PREFIX="/boot/home/config"
+# helps building libavcodec
+add_cflags "-DPIC -fomit-frame-pointer"
+# 3 gcc releases known for BeOS, each with ugly bugs
+gcc_version="`$cc -v 2>&1 | grep version | cut -d ' ' -f3-`"
+case "$gcc_version" in
+2.9-beos-991026*|2.9-beos-000224*) echo "R5/GG gcc"
+mmx="no"
+;;
+*20010315*) echo "BeBits gcc"
+add_cflags "-fno-expensive-optimizations"
+;;
+esac
+SHFLAGS=-nostart
+# disable Linux things
+audio_oss="no"
+video4linux="no"
+video4linux2="no"
+dv1394="no"
+# enable BeOS things
+audio_beos="yes"
+beosthreads="yes"
+# no need for libm, but the inet stuff
+# Check for BONE
+if (echo $BEINCLUDES|grep 'headers/be/bone' >/dev/null); then
+extralibs="-lbind -lsocket"
+else
+beos_netserver="yes"
+extralibs="-lnet"
+fi ;;
+SunOS)
+video4linux="no"
+video4linux2="no"
+audio_oss="no"
+dv1394="no"
+make="gmake"
+FFLDFLAGS=""
+FFSERVERLDFLAGS=""
+SHFLAGS="-shared -Wl,-h,\$@"
+add_extralibs "-lsocket -lnsl"
+;;
+NetBSD)
+video4linux="no"
+video4linux2="no"
+bktr="yes"
+audio_oss="yes"
+dv1394="no"
+make="gmake"
+add_extralibs "-lossaudio"
+;;
+OpenBSD)
+video4linux="no"
+video4linux2="no"
+bktr="yes"
+audio_oss="yes"
+dv1394="no"
+make="gmake"
+LIBOBJFLAGS="\$(PIC)"
+LDCONFIG="ldconfig -m \$(shlibdir)"
+add_extralibs "-lossaudio"
+;;
+FreeBSD)
+video4linux="no"
+video4linux2="no"
+bktr="yes"
+audio_oss="yes"
+dv1394="no"
+make="gmake"
+add_cflags "-pthread"
+;;
+GNU/kFreeBSD)
+video4linux="no"
+video4linux2="no"
+bktr="yes"
+audio_oss="yes"
+dv1394="no"
+add_cflags "-pthread"
+;;
+BSD/OS)
+video4linux="no"
+video4linux2="no"
+bktr="yes"
+audio_oss="yes"
+dv1394="no"
+extralibs="-lpoll -lgnugetopt -lm"
+make="gmake"
+strip="strip -d"
+installstrip=""
+;;
+Darwin)
+cc="cc"
+video4linux="no"
+video4linux2="no"
+audio_oss="no"
+dv1394="no"
+SHFLAGS="-dynamiclib -Wl,-single_module -Wl,-install_name,\$(shlibdir)/\$(SLIBNAME),-current_version,\$(SPPVERSION),-compatibility_version,\$(SPPVERSION)"
+VHOOKSHFLAGS='-dynamiclib -Wl,-single_module -flat_namespace -undefined suppress -Wl,-install_name,$(shlibdir)/vhook/$@'
+extralibs=""
+strip="strip -x"
+installstrip=""
+FFLDFLAGS="-Wl,-dynamic,-search_paths_first"
+SLIBSUF=".dylib"
+SLIBNAME_WITH_FULLVERSION='$(SLIBPREF)$(NAME).$(LIBVERSION)$(SLIBSUF)'
+SLIBNAME_WITH_MAJOR='$(SLIBPREF)$(NAME).$(LIBMAJOR)$(SLIBSUF)'
+FFSERVERLDFLAGS=-Wl,-bind_at_load
+LIB_INSTALL_EXTRA_CMD='$(RANLIB) "$(libdir)/$(LIB)"'
+;;
+MINGW32*)
+# Note: the rest of the mingw32 config is done afterwards as mingw32
+# can be forced on the command line for Linux cross compilation.
+mingw32="yes"
+;;
+CYGWIN*)
+targetos=CYGWIN
+shlibdir='${PREFIX}/bin'
+video4linux="no"
+video4linux2="no"
+audio_oss="yes"
+dv1394="no"
+VHOOKSHFLAGS='-shared -L$(BUILD_ROOT)/libavformat -L$(BUILD_ROOT)/libavcodec -L$(BUILD_ROOT)/libavutil'
+VHOOKLIBS='-lavformat$(BUILDSUF) -lavcodec$(BUILDSUF) -lavutil$(BUILDSUF) $(EXTRALIBS)'
+extralibs=""
+EXESUF=".exe"
+SLIBPREF="cyg"
+SLIBSUF=".dll"
+SLIBNAME_WITH_VERSION='$(SLIBPREF)$(NAME)-$(LIBVERSION)$(SLIBSUF)'
+SLIBNAME_WITH_MAJOR='$(SLIBPREF)$(NAME)-$(LIBMAJOR)$(SLIBSUF)'
+SHFLAGS='-shared -Wl,--out-implib=lib$(NAME).dll.a'
+;;
+Linux)
+LDLATEFLAGS="-Wl,--as-needed $LDLATEFLAGS"
+;;
+IRIX*)
+targetos=IRIX
+ranlib="echo ignoring ranlib"
+video4linux="no"
+video4linux2="no"
+audio_oss="no"
+make="gmake"
+;;
+OS/2)
+TMPE=$TMPE".exe"
+ar="emxomfar -p128"
+ranlib="echo ignoring ranlib"
+strip="echo ignoring strip"
+add_cflags "-Zomf"
+FFLDFLAGS="-Zomf -Zstack 16384 -s"
+SHFLAGS="-Zdll -Zomf"
+FFSERVERLDFLAGS=""
+LIBPREF=""
+LIBSUF=".lib"
+SLIBPREF=""
+SLIBSUF=".dll"
+EXESUF=".exe"
+extralibs=""
+pkg_requires=""
+video4linux="no"
+video4linux2="no"
+audio_oss="no"
+dv1394="no"
+ffserver="no"
+vhook="no"
+os2="yes"
+os2threads="yes"
+;;
+*)
+targetos="${targetos}-UNKNOWN"
+;;
+esac
+
+# find source path
+source_path="`dirname \"$0\"`"
+source_path_used="yes"
+if test -z "$source_path" -o "$source_path" = "." ; then
+ source_path="`pwd`"
+ source_path_used="no"
+else
+ source_path="`cd \"$source_path\"; pwd`"
+ echo "$source_path" | grep -q '[[:blank:]]' &&
+ die "Out of tree builds are impossible with whitespace in source path."
+fi
+
+if test x"$1" = x"-h" -o x"$1" = x"--help" ; then
+ show_help
+fi
+
+FFMPEG_CONFIGURATION=" "
+for opt do
+ FFMPEG_CONFIGURATION="$FFMPEG_CONFIGURATION""$opt "
+done
+
+ENCODER_LIST=`sed -n 's/^[^#]*ENC.*, *\(.*\)).*/\1_encoder/p' "$source_path/libavcodec/allcodecs.c"`
+DECODER_LIST=`sed -n 's/^[^#]*DEC.*, *\(.*\)).*/\1_decoder/p' "$source_path/libavcodec/allcodecs.c"`
+PARSER_LIST=`sed -n 's/^[^#]*PARSER.*, *\(.*\)).*/\1_parser/p' "$source_path/libavcodec/allcodecs.c"`
+MUXER_LIST=`sed -n 's/^[^#]*_MUX.*, *\(.*\)).*/\1_muxer/p' "$source_path/libavformat/allformats.c"`
+DEMUXER_LIST=`sed -n 's/^[^#]*DEMUX.*, *\(.*\)).*/\1_demuxer/p' "$source_path/libavformat/allformats.c"`
+
+enable $ENCODER_LIST $DECODER_LIST $PARSER_LIST $MUXER_LIST $DEMUXER_LIST
+
+for opt do
+ optval="${opt#*=}"
+ case "$opt" in
+ --log)
+ ;;
+ --log=*) logging="$optval"
+ ;;
+ --prefix=*) PREFIX="$optval"; force_prefix=yes
+ ;;
+ --libdir=*) libdir="$optval"; force_libdir=yes
+ ;;
+ --shlibdir=*) shlibdir="$optval"
+ ;;
+ --incdir=*) incdir="$optval"
+ ;;
+ --mandir=*) mandir="$optval"
+ ;;
+ --source-path=*) source_path="$optval"
+ ;;
+ --build-path=*) build_path="$optval"
+ ;;
+ --cross-prefix=*) cross_prefix="$optval"
+ ;;
+ --cross-compile) cross_compile=yes
+ ;;
+ --cc=*) cc="$optval"
+ ;;
+ --make=*) make="$optval"
+ ;;
+ --extra-cflags=*) add_cflags "$optval"
+ ;;
+ --extra-ldflags=*) add_ldflags "$optval"
+ ;;
+ --extra-libs=*) add_extralibs "$optval"
+ ;;
+ --build-suffix=*) BUILDSUF="$optval"
+ ;;
+ --arch=*) arch="$optval"
+ ;;
+ --cpu=*) cpu="$optval"
+ ;;
+ --powerpc-perf-enable) powerpc_perf="yes"
+ ;;
+ --disable-mmx) mmx="no"
+ ;;
+ --disable-armv5te) armv5te="no"
+ ;;
+ --disable-iwmmxt) iwmmxt="no"
+ ;;
+ --disable-altivec) altivec="no"
+ ;;
+ --enable-gprof) gprof="yes"
+ ;;
+ --disable-v4l) video4linux="no"
+ ;;
+ --disable-v4l2) video4linux2="no"
+ ;;
+ --disable-bktr) bktr="no"
+ ;;
+ --disable-audio-oss) audio_oss="no"
+ ;;
+ --disable-audio-beos) audio_beos="no"
+ ;;
+ --disable-dv1394) dv1394="no"
+ ;;
+ --disable-network) network="no"; ffserver="no"
+ ;;
+ --disable-ipv6) ipv6="no";
+ ;;
+ --disable-zlib) zlib="no"
+ ;;
+ --enable-a52) a52="yes"
+ ;;
+ --enable-a52bin) a52bin="yes"
+ ;;
+ --enable-dts) dts="yes"
+ ;;
+ --enable-pp) pp="yes"
+ ;;
+ --enable-libgsm) libgsm="yes"
+ ;;
+ --enable-mp3lame) mp3lame="yes"
+ ;;
+ --enable-libnut) libnut="yes"
+ ;;
+ --enable-libogg) libogg="yes"
+ pkg_requires="$pkg_requires ogg >= 1.1"
+ ;;
+ --enable-vorbis) libvorbis="yes"
+ pkg_requires="$pkg_requires vorbis vorbisenc"
+ ;;
+ --enable-faad) faad="yes"
+ ;;
+ --enable-faadbin) faadbin="yes"
+ ;;
+ --enable-faac) faac="yes"
+ ;;
+ --enable-xvid) xvid="yes"
+ ;;
+ --enable-x264) x264="yes"
+ ;;
+ --enable-avisynth) avisynth="yes";
+ ;;
+ --enable-dc1394) dc1394="yes"
+ pkg_requires="$pkg_requires libraw1394"
+ ;;
+ --disable-vhook) vhook="no"
+ ;;
+ --enable-mingw32) mingw32="yes"
+ ;;
+ --enable-mingwce) wince="yes"
+ ;;
+ --enable-static) lstatic="yes"
+ ;;
+ --disable-static) lstatic="no"
+ ;;
+ --enable-shared) lshared="yes"
+ ;;
+ --disable-shared) lshared="no"
+ ;;
+ --disable-debug) debug="no"
+ ;;
+ --disable-opts) optimize="no"
+ ;;
+ --enable-extra-warnings) extrawarnings="yes"
+ ;;
+ --disable-mpegaudio-hp) mpegaudio_hp="no"
+ ;;
+ --disable-protocols) protocols="no"; network="no"; ffserver="no"
+ ;;
+ --disable-ffmpeg) ffmpeg="no"
+ ;;
+ --disable-ffserver) ffserver="no"
+ ;;
+ --disable-ffplay) ffplay="no"
+ ;;
+ --enable-small) optimize="small"
+ ;;
+ --enable-amr_nb) amr="yes"; amr_nb="yes"; amr_nb_fixed="no"
+ ;;
+ --enable-amr_nb-fixed) amr="yes"; amr_nb_fixed="yes"; amr_nb="no"
+ ;;
+ --enable-amr_wb) amr="yes"; amr_wb="yes"
+ ;;
+ --enable-amr_if2) amr="yes"; amr_if2="yes"
+ ;;
+ --enable-sunmlib) mlib="yes"
+ ;;
+ --enable-pthreads) pthreads="yes"
+ ;;
+ --enable-swscaler) swscaler="yes"
+ ;;
+ --enable-gpl) gpl="yes"
+ ;;
+ --enable-memalign-hack) memalign_hack="yes"
+ ;;
+ --disable-strip) dostrip="no"
+ ;;
+ --enable-encoder=*) enable ${optval}_encoder
+ ;;
+ --enable-decoder=*) enable ${optval}_decoder
+ ;;
+ --disable-encoder=*) disable ${optval}_encoder
+ ;;
+ --disable-decoder=*) disable ${optval}_decoder
+ ;;
+ --disable-encoders) disable $ENCODER_LIST
+ ;;
+ --disable-decoders) disable $DECODER_LIST
+ ;;
+ --enable-muxer=*) enable ${optval}_muxer
+ ;;
+ --disable-muxer=*) disable ${optval}_muxer
+ ;;
+ --disable-muxers) disable $MUXER_LIST; ffserver="no"
+ ;;
+ --enable-demuxer=*) enable ${optval}_demuxer
+ ;;
+ --disable-demuxer=*) disable ${optval}_demuxer
+ ;;
+ --disable-demuxers) disable $DEMUXER_LIST
+ ;;
+ --enable-parser=*) enable ${optval}_parser
+ ;;
+ --disable-parser=*) disable ${optval}_parser
+ ;;
+ --disable-parsers) disable $PARSER_LIST
+ ;;
+ --help) show_help
+ ;;
+ *)
+ echo "Unknown option \"$opt\"."
+ echo "See $0 --help for available options."
+ exit 1
+ ;;
+ esac
+done
+
+cd "$build_path"
+
+if test "$logging" != no; then
+ test "$logging" = yes || logfile="$logging"
+ echo "# $0 $@" >$logfile
+ set >>$logfile
+else
+ logfile=/dev/null
+fi
+
+if test "$mingw32" = "yes" -o "$wince" = "yes"; then
+ if test "$lshared" = "yes" && test "$lstatic" = "yes" ; then
+ cat <<EOF
+You can only build one library type at once on MinGW.
+Specify --disable-static --enable-shared to only build
+the shared libraries. To build only the static libraries
+you do not need to pass additional options.
+EOF
+ exit 1
+ fi
+ video4linux="no"
+ video4linux2="no"
+ bktr="no"
+ audio_oss="no"
+ dv1394="no"
+ dc1394="no"
+ ffserver="no"
+ network="no"
+ if enabled mingw32; then
+ w32threads="yes"
+ fi
+ if test "$wince" = "yes"; then
+ protocols="no"
+ fi
+ SLIBPREF=""
+ SLIBSUF=".dll"
+ EXESUF=".exe"
+ SLIBNAME_WITH_VERSION='$(SLIBPREF)$(NAME)-$(LIBVERSION)$(SLIBSUF)'
+ SLIBNAME_WITH_MAJOR='$(SLIBPREF)$(NAME)-$(LIBMAJOR)$(SLIBSUF)'
+ SLIB_EXTRA_CMD="-lib /machine:i386 /def:\$(@:${SLIBSUF}=.def)"
+ SHFLAGS="-shared -Wl,--output-def,\$(@:${SLIBSUF}=.def),--out-implib,lib\$(SLIBNAME:\$(SLIBSUF)=.dll.a)"
+ if test "$force_prefix" != yes; then PREFIX="$PROGRAMFILES/FFmpeg"; fi
+ if test "$force_libdir" != yes; then bindir='${PREFIX}'; fi
+ shlibdir='${PREFIX}'
+fi
+
+# Combine FFLDFLAGS and the LDFLAGS environment variable.
+LDFLAGS="$FFLDFLAGS $LDFLAGS"
+
+test -n "$cross_prefix" && cross_compile=yes
+cc="${cross_prefix}${cc}"
+ar="${cross_prefix}${ar}"
+ranlib="${cross_prefix}${ranlib}"
+strip="${cross_prefix}${strip}"
+
+# we need to build at least one lib type
+if test "$lstatic" = "no" && test "$lshared" = "no" ; then
+ cat <<EOF
+At least one library type must be built.
+Specify --enable-static to build the static libraries or --enable-shared to
+build the shared libraries as well. To only build the shared libraries specify
+--disable-static in addition to --enable-shared.
+EOF
+ exit 1;
+fi
+
+if test "$libvorbis" = "yes" ; then
+ if test "$libogg" = "no"; then
+ echo "libogg must be enabled to enable Vorbis."
+ fail="yes"
+ fi
+fi
+
+if test "$gpl" != "yes"; then
+ if test "$pp" != "no"; then
+ echo "The Postprocessing code is under GPL and --enable-gpl is not specified."
+ fail="yes"
+ fi
+
+ if test "$a52" != "no" -o "$a52bin" != "no"; then
+ echo "liba52 is under GPL and --enable-gpl is not specified."
+ fail="yes"
+ fi
+
+ if test "$xvid" != "no"; then
+ echo "libxvidcore is under GPL and --enable-gpl is not specified."
+ fail="yes"
+ fi
+
+ if test "$x264" != "no"; then
+ echo "x264 is under GPL and --enable-gpl is not specified."
+ fail="yes"
+ fi
+
+ if test "$dts" != "no"; then
+ echo "libdts is under GPL and --enable-gpl is not specified."
+ fail="yes"
+ fi
+
+ if test "$faad" != "no" -o "$faadbin" != "no"; then
+ if check_header faad.h; then
+ check_cc << EOF
+ #include <faad.h>
+ #ifndef FAAD2_VERSION
+ ok faad1
+ #endif
+ int main( void ) { return 0; }
+EOF
+ if test $? = 0 ; then
+ echo "FAAD2 is under GPL and --enable-gpl is not specified."
+ fail="yes"
+ fi
+ else
+ faad="no"
+ faadbin="no"
+ echo "FAAD test failed."
+ fi
+ fi
+
+ if test "$swscaler" != "no"; then
+ echo "The software scaler is under GPL and --enable-gpl is not specified."
+ fail="yes"
+ fi
+fi
+
+if test "$fail" = "yes"; then
+ exit 1
+fi
+
+# compute MMX state
+if test $mmx = "default"; then
+ if test $arch = "x86_32" -o $arch = "x86_64"; then
+ mmx="yes"
+ else
+ mmx="no"
+ fi
+fi
+
+#Darwin CC versions
+needmdynamicnopic="no"
+if test $targetos = Darwin; then
+ if test -n "`$cc -v 2>&1 | grep xlc`"; then
+ add_cflags "-qpdf2 -qlanglvl=extc99 -qmaxmem=-1 -qarch=auto -qtune=auto"
+ else
+ gcc_version="`$cc -v 2>&1 | grep version | cut -d ' ' -f3-`"
+ case "$gcc_version" in
+ *2.95*)
+ add_cflags "-no-cpp-precomp -pipe"
+ ;;
+ *[34].*)
+ add_cflags "-no-cpp-precomp -pipe -force_cpusubtype_ALL -Wno-sign-compare"
+ if test "$lshared" = no; then
+ needmdynamicnopic="yes"
+ fi
+ ;;
+ *)
+ add_cflags "-no-cpp-precomp -pipe"
+ if test "$lshared" = no; then
+ needmdynamicnopic="yes"
+ fi
+ ;;
+ esac
+ fi
+fi
+
+if test $optimize != "no"; then
+ add_cflags "-fomit-frame-pointer"
+fi
+
+# Can only do AltiVec on PowerPC
+if test $altivec = "default"; then
+ if test $arch = "powerpc"; then
+ altivec="yes"
+ else
+ altivec="no"
+ fi
+fi
+
+# Add processor-specific flags
+POWERPCMODE="32bits"
+if test $cpu != "generic"; then
+ case $cpu in
+ 601|ppc601|PowerPC601)
+ add_cflags "-mcpu=601"
+ if test $altivec = "yes"; then
+ echo "WARNING: Tuning for PPC601 but AltiVec enabled!";
+ fi
+ ;;
+ 603*|ppc603*|PowerPC603*)
+ add_cflags "-mcpu=603"
+ if test $altivec = "yes"; then
+ echo "WARNING: Tuning for PPC603 but AltiVec enabled!";
+ fi
+ ;;
+ 604*|ppc604*|PowerPC604*)
+ add_cflags "-mcpu=604"
+ if test $altivec = "yes"; then
+ echo "WARNING: Tuning for PPC604 but AltiVec enabled!";
+ fi
+ ;;
+ G3|g3|75*|ppc75*|PowerPC75*)
+ add_cflags "-mcpu=750 -mpowerpc-gfxopt"
+ if test $altivec = "yes"; then
+ echo "WARNING: Tuning for PPC75x but AltiVec enabled!";
+ fi
+ ;;
+ G4|g4|745*|ppc745*|PowerPC745*)
+ add_cflags "-mcpu=7450 -mpowerpc-gfxopt"
+ if test $altivec = "no"; then
+ echo "WARNING: Tuning for PPC745x but AltiVec disabled!";
+ fi
+ ;;
+ 74*|ppc74*|PowerPC74*)
+ add_cflags "-mcpu=7400 -mpowerpc-gfxopt"
+ if test $altivec = "no"; then
+ echo "WARNING: Tuning for PPC74xx but AltiVec disabled!";
+ fi
+ ;;
+ G5|g5|970|ppc970|PowerPC970|power4*|Power4*)
+ add_cflags "-mcpu=970 -mpowerpc-gfxopt -mpowerpc64"
+ if test $altivec = "no"; then
+ echo "WARNING: Tuning for PPC970 but AltiVec disabled!";
+ fi
+ POWERPCMODE="64bits"
+ ;;
+ # targets that do NOT support conditional mov (cmov)
+ i[345]86|pentium|pentium-mmx|k6|k6-[23]|winchip-c6|winchip2|c3)
+ add_cflags "-march=$cpu"
+ cmov="no"
+ ;;
+ # targets that do support conditional mov (cmov)
+ i686|pentiumpro|pentium[23]|pentium-m|athlon|athlon-tbird|athlon-4|athlon-[mx]p|athlon64|k8|opteron|athlon-fx)
+ add_cflags "-march=$cpu"
+ cmov="yes"
+ cmov_is_fast="yes"
+ ;;
+ # targets that do support conditional mov but on which it's slow
+ pentium4|prescott|nocona)
+ add_cflags "-march=$cpu"
+ cmov="yes"
+ cmov_is_fast="no"
+ ;;
+ sparc64)
+ add_cflags "-mcpu=v9"
+ ;;
+ *)
+ echo "WARNING: Unknown CPU \"$cpu\", ignored."
+ ;;
+ esac
+fi
+
+# make sure we can execute files in $TMPDIR
+cat >$TMPE 2>>$logfile <<EOF
+#! /bin/sh
+EOF
+chmod +x $TMPE >>$logfile 2>&1
+if ! $TMPE >>$logfile 2>&1; then
+ cat <<EOF
+Unable to create and execute files in $TMPDIR1. Set the TMPDIR environment
+variable to another directory and make sure that $TMPDIR1 is not mounted
+noexec.
+EOF
+ die "Sanity test failed."
+fi
+rm $TMPE
+
+# compiler sanity check
+check_exec <<EOF
+int main(){
+ return 0;
+}
+EOF
+if test "$?" != 0; then
+ echo "$cc is unable to create an executable file."
+ if test -z "$cross_prefix" -a "$cross_compile" = no; then
+ echo "If $cc is a cross-compiler, use the --cross-compile option."
+ echo "Only do this if you know what cross compiling means."
+ fi
+ die "C compiler test failed."
+fi
+
+# check for assembler specific support
+
+if test $arch = "powerpc"; then
+check_cc <<EOF && dcbzl=yes
+int main(void) {
+ register long zero = 0;
+ char data[1024];
+ asm volatile("dcbzl %0, %1" : : "b" (data), "r" (zero));
+return 0;
+}
+EOF
+fi
+
+# check for SIMD availability
+
+# AltiVec flags: The FSF version of GCC differs from the Apple version
+if test $arch = "powerpc"; then
+ if test $altivec = "yes"; then
+ if test -n "`$cc -v 2>&1 | grep version | grep Apple`"; then
+ add_cflags "-faltivec"
+ else
+ add_cflags "-maltivec -mabi=altivec"
+ fi
+ fi
+fi
+
+check_header altivec.h
+
+# check if our compiler supports Motorola AltiVec C API
+if test $altivec = "yes"; then
+ if test $altivec_h = "yes"; then
+ inc_altivec_h="#include <altivec.h>"
+ else
+ inc_altivec_h=
+ fi
+ check_cc <<EOF || altivec=no
+$inc_altivec_h
+int main(void) {
+ vector signed int v1, v2, v3;
+ v1 = vec_add(v2,v3);
+ return 0;
+}
+EOF
+fi
+
+# check armv5te instructions support
+if test $armv5te = "default" -a $arch = "armv4l"; then
+ armv5te=no
+ check_cc <<EOF && armv5te=yes
+ int main(void) {
+ __asm__ __volatile__ ("qadd r0, r0, r0");
+ }
+EOF
+fi
+
+# check iwmmxt support
+if test $iwmmxt = "default" -a $arch = "armv4l"; then
+ iwmmxt=no
+ check_cc <<EOF && iwmmxt=yes
+ int main(void) {
+ __asm__ __volatile__ ("wunpckelub wr6, wr4");
+ }
+EOF
+fi
+
+# mmi only available on mips
+if test $mmi = "default"; then
+ if test $arch = "mips"; then
+ mmi="yes"
+ else
+ mmi="no"
+ fi
+fi
+
+# check if our compiler supports mmi
+enabled mmi && check_cc <<EOF || mmi="no"
+int main(void) {
+ __asm__ ("lq \$2, 0(\$2)");
+ return 0;
+}
+EOF
+
+# ---
+# big/little-endian test
+if test "$cross_compile" = "no"; then
+ check_ld <<EOF || die "endian test failed" && $TMPE && bigendian="yes"
+#include <inttypes.h>
+int main(int argc, char ** argv){
+ volatile uint32_t i=0x01234567;
+ return (*((uint8_t*)(&i))) == 0x67;
+}
+EOF
+else
+ # programs cannot be launched if cross compiling, so make a static guess
+ if test "$arch" = "powerpc" -o "$arch" = "mips" ; then
+ bigendian="yes"
+ fi
+fi
+
+# ---
+# check availability of some header files
+
+check_header malloc.h
+check_func memalign
+
+if test "$memalign" = "no" -a "$mmx" = "yes" -a \
+ "$memalign_hack" != "yes" -a "$targetos" != "Darwin" -a \
+ "$targetos" != "FreeBSD" ; then
+ die "Error, no memalign() but SSE enabled, disable it or use --enable-memalign-hack."
+fi
+
+check_header byteswap.h
+
+check_func inet_aton
+check_func localtime_r
+enabled zlib && check_lib zlib.h zlibVersion -lz || zlib="no"
+
+# check for some common methods of building with pthread support
+# do this before the optional library checks as some of them require pthreads
+if enabled pthreads; then
+ if check_func pthread_create; then
+ :
+ elif check_func pthread_create -pthread; then
+ add_cflags -pthread
+ add_ldflags -pthread
+ elif check_func pthread_create -pthreads; then
+ add_cflags -pthreads
+ add_ldflags -pthreads
+ elif ! check_lib pthread.h pthread_create -lpthread; then
+ die "ERROR: can't find pthreads library"
+ fi
+fi
+
+# these are off by default, so fail if requested and not available
+enabled dts && require libdts dts.h dts_init -ldts -lm
+enabled libgsm && require libgsm gsm.h gsm_create -lgsm
+enabled mp3lame && require LAME lame/lame.h lame_init -lmp3lame -lm
+enabled libvorbis && require libvorbis vorbis/vorbisenc.h vorbis_info_init -lvorbis -lvorbisenc -logg
+enabled libogg && require libogg ogg/ogg.h ogg_sync_init -logg
+enabled libnut && require libnut libnut.h nut_demuxer_init -lnut
+enabled xvid && require XviD xvid.h xvid_global -lxvidcore
+enabled x264 && require x264 x264.h x264_encoder_open -lx264
+enabled dc1394 && require libdc1394 libdc1394/dc1394_control.h dc1394_create_handle -ldc1394_control -lraw1394
+enabled mlib && require mediaLib mlib_types.h mlib_VectorSub_S16_U8_Mod -lmlib
+
+# Ugh, faac uses stdcall calling convention on win32 so we can't use
+# the generic test functions
+if enabled faac; then
+ save_flags
+ temp_extralibs -lfaac
+ check_ld <<EOF && add_extralibs -lfaac || die "ERROR: libfaac not found"
+#include <stdint.h>
+#include <faac.h>
+int main(){
+ char *id, *cpr;
+ faacEncGetVersion(&id, &cpr);
+ return 0;
+}
+EOF
+ restore_flags
+fi
+
+# Ugh, recent faad2 versions have renamed all functions and #define the
+# old names in faad.h. Generic tests won't work.
+if enabled faad; then
+ save_flags
+ temp_extralibs -lfaad
+ check_ld <<EOF && add_extralibs -lfaad || die "ERROR: libfaad not found"
+#include <faad.h>
+int main(){
+ faacDecOpen();
+ return 0;
+}
+EOF
+ restore_flags
+fi
+
+# Ugh, avisynth uses WINAPI calls. Generic tests won't work.
+if enabled avisynth; then
+ save_flags
+ temp_extralibs -lvfw32
+ check_ld <<EOF && add_extralibs -lvfw32 || die "ERROR: vfw32 not found"
+#include <windows.h>
+#include <vfw.h>
+int main(){
+ AVIFileInit();
+ return 0;
+}
+EOF
+ restore_flags
+fi
+
+
+# test for lrintf in math.h
+check_exec <<EOF && lrintf=yes || lrintf=no
+#define _ISOC9X_SOURCE 1
+#include <math.h>
+int main( void ) { return (lrintf(3.999f) > 0)?0:1; }
+EOF
+
+_restrict=
+for restrict_keyword in restrict __restrict__ __restrict; do
+ check_cc <<EOF && _restrict=$restrict_keyword && break
+void foo(char * $restrict_keyword p);
+EOF
+done
+
+# dlopen/dlfcn.h probing
+
+check_header dlfcn.h
+
+if check_func dlopen; then
+ ldl=
+elif check_func dlopen -ldl; then
+ ldl=-ldl
+fi
+
+if test "$vhook" = "default"; then
+ vhook="$dlopen"
+fi
+
+if enabled_any vhook a52bin faadbin; then
+ add_extralibs $ldl
+fi
+
+if test "$targetos" = "CYGWIN" -a "$lstatic" = "yes" ; then
+ vhook="no"
+ echo
+ echo "At the moment vhooks don't work on Cygwin static builds."
+ echo "Patches welcome."
+ echo
+fi
+
+if enabled vhook; then
+ check_ldflags -rdynamic
+ check_ldflags -export-dynamic
+fi
+
+if enabled audio_beos; then
+ add_extralibs "-lmedia -lbe"
+fi
+
+##########################################
+# imlib check
+
+temp_extralibs -lImlib2
+check_ld <<EOF && imlib2=yes || imlib2=no
+#include <X11/Xlib.h>
+#include <Imlib2.h>
+int main( void ) { return (int) imlib_load_font("foo"); }
+EOF
+restore_flags
+
+##########################################
+# FreeType check
+
+freetype2=no
+if test "x$targetos" != "xBeOS"; then
+ if (freetype-config --version) >/dev/null 2>&1 ; then
+ temp_cflags `freetype-config --cflags`
+ temp_extralibs `freetype-config --libs`
+ check_ld <<EOF && freetype2=yes
+#include <ft2build.h>
+int main( void ) { return (int) FT_Init_FreeType(0); }
+EOF
+ restore_flags
+ fi
+fi
+
+##########################################
+# SDL check
+
+sdl_too_old=no
+sdl=no
+SDL_CONFIG="${cross_prefix}sdl-config"
+if ("${SDL_CONFIG}" --version) >/dev/null 2>&1 ; then
+ temp_cflags `"${SDL_CONFIG}" --cflags`
+ temp_extralibs `"${SDL_CONFIG}" --libs`
+ check_ld <<EOF
+#include <SDL.h>
+#undef main /* We don't want SDL to override our main() */
+int main( void ) { return SDL_Init (SDL_INIT_VIDEO); }
+EOF
+ if test $? = 0; then
+ _sdlversion=`"${SDL_CONFIG}" --version | sed 's/[^0-9]//g'`
+ if test "$_sdlversion" -lt 121 ; then
+ sdl_too_old=yes
+ else
+ sdl=yes
+ check_cc <<EOF && sdl_video_size=yes || sdl_video_size=no
+#include <SDL.h>
+int main(void){
+ const SDL_VideoInfo *vi = SDL_GetVideoInfo();
+ int w = vi->current_w;
+ return 0;
+}
+EOF
+ fi
+ fi
+ restore_flags
+fi
+
+enabled sdl || ffplay=no
+
+##########################################
+# texi2html check
+
+texi2html=no
+if (texi2html -version) >/dev/null 2>&1; then
+texi2html=yes
+fi
+
+##########################################
+# IPv6 check
+
+enabled network && enabled ipv6 && check_ld <<EOF && ipv6=yes || ipv6=no
+#include <sys/types.h>
+#include <sys/socket.h>
+#include <netinet/in.h>
+#include <netdb.h>
+int main( void ) {
+ struct sockaddr_storage saddr;
+ struct ipv6_mreq mreq6;
+ getaddrinfo(0,0,0,0);
+ getnameinfo(0,0,0,0,0,0,0);
+ IN6_IS_ADDR_MULTICAST((const struct in6_addr *)0);
+}
+EOF
+
+# check for video4linux2 --- V4L2_PIX_FMT_YUV420
+enabled video4linux2 && check_cc <<EOF || video4linux2="no"
+#include <sys/time.h>
+#include <asm/types.h>
+#include <linux/videodev2.h>
+int dummy = V4L2_PIX_FMT_YUV420;
+struct v4l2_buffer dummy1;
+EOF
+
+enabled debug && add_cflags -g
+
+# add some useful compiler flags if supported
+check_cflags -Wdeclaration-after-statement
+check_cflags -Wall
+check_cflags -Wno-switch
+check_cflags -Wdisabled-optimization
+check_cflags -Wpointer-arith
+check_cflags -Wredundant-decls
+enabled extrawarnings && check_cflags -Winline
+
+# add some linker flags
+check_ldflags $LDLATEFLAGS
+
+# not all compilers support -Os
+test "$optimize" = "small" && check_cflags -Os
+
+if enabled optimize; then
+ if test -n "`$cc -v 2>&1 | grep xlc`"; then
+ add_cflags "-O5"
+ add_ldflags "-O5"
+ else
+ add_cflags "-O3"
+ fi
+fi
+
+# PIC flags for shared library objects where they are needed
+if test "$lshared" = "yes" ; then
+ # LIBOBJFLAGS may have already been set in the OS configuration
+ if test -z "$LIBOBJFLAGS" ; then
+ case "$arch" in
+ x86_64|ia64|alpha|sparc*) LIBOBJFLAGS="\$(PIC)" ;;
+ esac
+ fi
+fi
+
+if test "$gprof" = "yes" ; then
+ add_cflags "-p"
+ add_ldflags "-p"
+fi
+
+VHOOKCFLAGS="-fPIC $CFLAGS"
+test "$needmdynamicnopic" = yes && add_cflags -mdynamic-no-pic
+
+# find if .align arg is power-of-two or not
+if test $asmalign_pot = "unknown"; then
+ asmalign_pot="no"
+ echo 'asm (".align 3");' | check_cc && asmalign_pot="yes"
+fi
+
+echo "install prefix $PREFIX"
+echo "source path $source_path"
+echo "C compiler $cc"
+echo "make $make"
+echo "ARCH $arch ($cpu)"
+if test "$BUILDSUF" != ""; then
+ echo "build suffix $BUILDSUF"
+fi
+echo "big-endian $bigendian"
+if test $arch = "x86_32" -o $arch = "x86_64"; then
+ echo "MMX enabled $mmx"
+ echo "CMOV enabled $cmov"
+ echo "CMOV is fast $cmov_is_fast"
+fi
+if test $arch = "armv4l"; then
+ echo "ARMv5TE enabled $armv5te"
+ echo "IWMMXT enabled $iwmmxt"
+fi
+if test $arch = "mips"; then
+ echo "MMI enabled $mmi"
+fi
+if test $arch = "powerpc"; then
+ echo "AltiVec enabled $altivec"
+ echo "dcbzl available $dcbzl"
+fi
+echo "gprof enabled $gprof"
+echo "zlib enabled $zlib"
+echo "libgsm enabled $libgsm"
+echo "mp3lame enabled $mp3lame"
+echo "libnut enabled $libnut"
+echo "libogg enabled $libogg"
+echo "Vorbis enabled $libvorbis"
+echo "FAAD enabled $faad"
+echo "faadbin enabled $faadbin"
+echo "FAAC enabled $faac"
+echo "XviD enabled $xvid"
+echo "x264 enabled $x264"
+echo "a52 support $a52"
+echo "a52 dlopened $a52bin"
+echo "DTS support $dts"
+echo "pp support $pp"
+echo "Software Scaler enabled $swscaler"
+echo "AVISynth enabled $avisynth"
+echo "debug symbols $debug"
+echo "strip symbols $dostrip"
+echo "optimize $optimize"
+echo "static $lstatic"
+echo "shared $lshared"
+echo "video hooking $vhook"
+echo "SDL support $sdl"
+if test $sdl_too_old = "yes"; then
+ echo "-> Your SDL version is too old - please upgrade to have FFplay/SDL support."
+fi
+
+if test "$vhook" = "yes"; then
+ echo "Imlib2 support $imlib2"
+ echo "FreeType support $freetype2"
+fi
+echo "Sun medialib support" $mlib
+echo "pthreads support" $pthreads
+echo "AMR-NB float support" $amr_nb
+echo "AMR-NB fixed support" $amr_nb_fixed
+echo "AMR-WB float support" $amr_wb
+echo "AMR-WB IF2 support" $amr_if2
+echo "network support $network"
+if test "$network" = "yes" ; then
+ echo "IPv6 support $ipv6"
+fi
+echo ".align is power-of-two" $asmalign_pot
+if test "$gpl" = "no" ; then
+ echo "License: LGPL"
+else
+ echo "License: GPL"
+fi
+
+echo "Creating config.mak and config.h..."
+
+echo "# Automatically generated by configure - do not modify!" > config.mak
+echo "/* Automatically generated by configure - do not modify! */" > $TMPH
+echo "#define FFMPEG_CONFIGURATION "'"'"$FFMPEG_CONFIGURATION"'"' >> $TMPH
+
+echo "PREFIX=$PREFIX" >> config.mak
+echo "prefix=\$(DESTDIR)\${PREFIX}" >> config.mak
+echo "libdir=\$(DESTDIR)$libdir" >> config.mak
+echo "shlibdir=\$(DESTDIR)$shlibdir" >> config.mak
+echo "incdir=\$(DESTDIR)$incdir" >> config.mak
+echo "bindir=\$(DESTDIR)$bindir" >> config.mak
+echo "mandir=\$(DESTDIR)$mandir" >> config.mak
+echo "MAKE=$make" >> config.mak
+echo "CC=$cc" >> config.mak
+echo "AR=$ar" >> config.mak
+echo "RANLIB=$ranlib" >> config.mak
+if test "$dostrip" = "yes" ; then
+ echo "STRIP=$strip" >> config.mak
+ echo "INSTALLSTRIP=$installstrip" >> config.mak
+else
+ echo "STRIP=echo ignoring strip" >> config.mak
+ echo "INSTALLSTRIP=" >> config.mak
+fi
+
+echo "OPTFLAGS=$CFLAGS" >> config.mak
+echo "VHOOKCFLAGS=$VHOOKCFLAGS">>config.mak
+echo "LDFLAGS=$LDFLAGS" >> config.mak
+echo "LDCONFIG=$LDCONFIG" >> config.mak
+echo "FFSERVERLDFLAGS=$FFSERVERLDFLAGS" >> config.mak
+echo "SHFLAGS=$SHFLAGS" >> config.mak
+echo "VHOOKSHFLAGS=$VHOOKSHFLAGS" >> config.mak
+echo "VHOOKLIBS=$VHOOKLIBS" >> config.mak
+echo "LIBOBJFLAGS=$LIBOBJFLAGS" >> config.mak
+echo "BUILD_STATIC=$lstatic" >> config.mak
+echo "BUILDSUF=$BUILDSUF" >> config.mak
+echo "LIBPREF=$LIBPREF" >> config.mak
+echo "LIBSUF=\${BUILDSUF}$LIBSUF" >> config.mak
+if test "$lstatic" = "yes" ; then
+ echo "LIB=$LIB" >> config.mak
+else # Some Make complain if this variable does not exist.
+ echo "LIB=" >> config.mak
+fi
+echo "SLIBPREF=$SLIBPREF" >> config.mak
+echo "SLIBSUF=\${BUILDSUF}$SLIBSUF" >> config.mak
+echo "EXESUF=\${BUILDSUF}$EXESUF" >> config.mak
+echo "TARGET_OS=$targetos" >> config.mak
+
+ucarch=`toupper $arch`
+echo "TARGET_ARCH_${ucarch}=yes" >> config.mak
+echo "#define ARCH_${ucarch} 1" >> $TMPH
+
+# special cases
+case "$arch" in
+ x86_32|x86_64)
+ echo "TARGET_ARCH_X86=yes" >> config.mak
+ echo "#define ARCH_X86 1" >> $TMPH
+ ;;
+ powerpc)
+ if test "$POWERPCMODE" = "64bits"; then
+ echo "#define POWERPC_MODE_64BITS 1" >> $TMPH
+ fi
+ if test "$powerpc_perf" = "yes"; then
+ echo "#define POWERPC_PERFORMANCE_REPORT 1" >> $TMPH
+ fi
+ ;;
+ sparc64)
+ echo "TARGET_ARCH_SPARC=yes" >> config.mak
+ echo "#define ARCH_SPARC 1" >> $TMPH
+ ;;
+esac
+
+if test "$bigendian" = "yes" ; then
+ echo "WORDS_BIGENDIAN=yes" >> config.mak
+ echo "#define WORDS_BIGENDIAN 1" >> $TMPH
+fi
+if test "$mmx" = "yes" ; then
+ echo "TARGET_MMX=yes" >> config.mak
+ echo "#define HAVE_MMX 1" >> $TMPH
+ echo "#define __CPU__ 586" >> $TMPH
+fi
+if test "$cmov" = "yes" ; then
+ echo "TARGET_CMOV=yes" >> config.mak
+ echo "#define HAVE_CMOV 1" >> $TMPH
+fi
+if test "$cmov_is_fast" = "yes" ; then
+ echo "TARGET_CMOV_IS_FAST=yes" >> config.mak
+ echo "#define CMOV_IS_FAST 1" >> $TMPH
+fi
+if test "$armv5te" = "yes" ; then
+ echo "TARGET_ARMV5TE=yes" >> config.mak
+ echo "#define HAVE_ARMV5TE 1" >> $TMPH
+fi
+if test "$iwmmxt" = "yes" ; then
+ echo "TARGET_IWMMXT=yes" >> config.mak
+ echo "#define HAVE_IWMMXT 1" >> $TMPH
+fi
+if test "$mmi" = "yes" ; then
+ echo "TARGET_MMI=yes" >> config.mak
+ echo "#define HAVE_MMI 1" >> $TMPH
+fi
+
+if test "$altivec" = "yes" ; then
+ echo "TARGET_ALTIVEC=yes" >> config.mak
+ echo "#define HAVE_ALTIVEC 1" >> $TMPH
+fi
+
+if test "$sdl" = "yes" ; then
+ echo "SDL_LIBS=`"${SDL_CONFIG}" --libs`" >> config.mak
+ echo "SDL_CFLAGS=`"${SDL_CONFIG}" --cflags`" >> config.mak
+fi
+if test "$texi2html" = "yes"; then
+ echo "BUILD_DOC=yes" >> config.mak
+fi
+
+sws_version=`grep '#define LIBSWSCALE_VERSION ' "$source_path/libswscale/swscale.h" | sed 's/[^0-9\.]//g'`
+pp_version=`grep '#define LIBPOSTPROC_VERSION ' "$source_path/libpostproc/postprocess.h" | sed 's/[^0-9\.]//g'`
+lavc_version=`grep '#define LIBAVCODEC_VERSION ' "$source_path/libavcodec/avcodec.h" | sed 's/[^0-9\.]//g'`
+lavf_version=`grep '#define LIBAVFORMAT_VERSION ' "$source_path/libavformat/avformat.h" | sed 's/[^0-9\.]//g'`
+lavu_version=`grep '#define LIBAVUTIL_VERSION ' "$source_path/libavutil/avutil.h" | sed 's/[^0-9\.]//g'`
+
+
+
+if test "$lshared" = "yes" ; then
+ echo "#define BUILD_SHARED_AV 1" >> $TMPH
+ echo "BUILD_SHARED=yes" >> config.mak
+ echo "PIC=-fPIC -DPIC" >> config.mak
+ echo "SPPMAJOR=${lavc_version%%.*}" >> config.mak
+ echo "SPPVERSION=$lavc_version" >> config.mak
+ echo "LAVCMAJOR=${lavc_version%%.*}" >> config.mak
+ echo "LAVCVERSION=$lavc_version" >> config.mak
+ echo "LAVFMAJOR=${lavf_version%%.*}" >> config.mak
+ echo "LAVFVERSION=$lavf_version" >> config.mak
+ echo "LAVUMAJOR=${lavu_version%%.*}" >> config.mak
+ echo "LAVUVERSION=$lavu_version" >> config.mak
+ echo "SWSMAJOR=${sws_version%%.*}" >> config.mak
+ echo "SWSVERSION=$sws_version" >> config.mak
+ echo "SLIBNAME=${SLIBNAME}" >> config.mak
+ echo "SLIBNAME_WITH_VERSION=${SLIBNAME_WITH_VERSION}" >> config.mak
+ echo "SLIBNAME_WITH_MAJOR=${SLIBNAME_WITH_MAJOR}" >> config.mak
+ echo "SLIB_EXTRA_CMD=${SLIB_EXTRA_CMD}" >> config.mak
+fi
+echo "LIB_INSTALL_EXTRA_CMD=${LIB_INSTALL_EXTRA_CMD}" >> config.mak
+echo "EXTRALIBS=$extralibs" >> config.mak
+
+enabled_any $ENCODER_LIST && enable encoders
+enabled_any $DECODER_LIST && enable decoders
+enabled_any $MUXER_LIST && enable muxers
+enabled_any $DEMUXER_LIST && enable demuxers
+
+enabled_any pthreads beosthreads os2threads w32threads && enable threads
+
+print_config HAVE_ $TMPH config.mak $HAVE_LIST
+print_config CONFIG_ $TMPH config.mak $CONFIG_LIST
+
+if test "$targetos" = "Darwin"; then
+ echo "#define CONFIG_DARWIN 1" >> $TMPH
+fi
+
+echo "#define restrict $_restrict" >> $TMPH
+
+if test "$optimize" = "small"; then
+ echo "#define always_inline" >> $TMPH
+ echo "#define CONFIG_SMALL 1" >> $TMPH
+fi
+
+echo "SRC_PATH=\"$source_path\"" >> config.mak
+echo "SRC_PATH_BARE=$source_path" >> config.mak
+echo "BUILD_ROOT=\"$PWD\"" >> config.mak
+
+if test "$amr_if2" = "yes" ; then
+ echo "AMR_CFLAGS=-DIF2=1" >> config.mak
+fi
+
+# Apparently it's not possible to portably echo a backslash.
+if test "$asmalign_pot" = "yes" ; then
+ printf '#define ASMALIGN(ZEROBITS) ".align " #ZEROBITS "\\n\\t"\n' >> $TMPH
+else
+ printf '#define ASMALIGN(ZEROBITS) ".align 1<<" #ZEROBITS "\\n\\t"\n' >> $TMPH
+fi
+
+
+for codec in $DECODER_LIST $ENCODER_LIST $PARSER_LIST $DEMUXER_LIST $MUXER_LIST; do
+ ucname="`toupper $codec`"
+ config_name="CONFIG_$ucname"
+ enabled_name="ENABLE_$ucname"
+ if enabled $codec; then
+ echo "#define $config_name 1" >> $TMPH
+ echo "#define $enabled_name 1" >> $TMPH
+ echo "$config_name=yes" >> config.mak
+ else
+ echo "#define $enabled_name 0" >> $TMPH
+ fi
+done
+
+# Do not overwrite config.h if unchanged to avoid superfluous rebuilds.
+if ! cmp -s $TMPH config.h; then
+ mv -f $TMPH config.h
+else
+ echo "config.h is unchanged"
+fi
+
+rm -f $TMPO $TMPC $TMPE $TMPS $TMPH
+
+# build tree in object directory if source path is different from current one
+if test "$source_path_used" = "yes" ; then
+ DIRS="\
+ doc \
+ libavformat \
+ libavcodec \
+ libavcodec/alpha \
+ libavcodec/armv4l \
+ libavcodec/bfin \
+ libavcodec/i386 \
+ libavcodec/sparc \
+ libavcodec/mlib \
+ libavcodec/ppc \
+ libavcodec/liba52 \
+ libpostproc \
+ libavutil \
+ libswscale \
+ tests \
+ vhook \
+ "
+ FILES="\
+ Makefile \
+ common.mak \
+ libavformat/Makefile \
+ libavcodec/Makefile \
+ libpostproc/Makefile \
+ libavutil/Makefile \
+ libswscale/Makefile \
+ tests/Makefile \
+ vhook/Makefile \
+ doc/Makefile \
+ doc/texi2pod.pl \
+ "
+ for dir in $DIRS ; do
+ mkdir -p $dir
+ done
+ for f in $FILES ; do
+ ln -sf "$source_path/$f" $f
+ done
+fi
+
+# build pkg-config files libav*.pc and libpostproc.pc
+# libavutil.pc
+cat <<EOF >libavutil.pc
+prefix=$PREFIX
+exec_prefix=\${prefix}
+libdir=\${exec_prefix}/lib
+includedir=\${prefix}/include
+
+Name: libavutil
+Description: FFmpeg utility library
+Version: $lavu_version
+Requires:
+Conflicts:
+Libs: -L\${libdir} -lavutil
+Cflags: -I\${includedir} -I\${includedir}/ffmpeg
+EOF
+
+cat <<EOF >libavutil-uninstalled.pc
+prefix=
+exec_prefix=
+libdir=\${pcfiledir}/libavutil
+includedir=\${pcfiledir}/libavutil
+
+Name: libavutil
+Description: FFmpeg utility library
+Version: $lavu_version
+Requires:
+Conflicts:
+Libs: \${libdir}/${LIBPREF}avutil${LIBSUF}
+Cflags: -I\${includedir}
+EOF
+
+# libavcodec.pc
+cat <<EOF >libavcodec.pc
+prefix=$PREFIX
+exec_prefix=\${prefix}
+libdir=\${exec_prefix}/lib
+includedir=\${prefix}/include
+
+Name: libavcodec
+Description: FFmpeg codec library
+Version: $lavc_version
+Requires: $pkg_requires libavutil = $lavu_version
+Conflicts:
+Libs: -L\${libdir} -lavcodec $extralibs
+Cflags: -I\${includedir} -I\${includedir}/ffmpeg
+EOF
+
+cat <<EOF >libavcodec-uninstalled.pc
+prefix=
+exec_prefix=
+libdir=\${pcfiledir}/libavcodec
+includedir=\${pcfiledir}/libavcodec
+
+Name: libavcodec
+Description: FFmpeg codec library
+Version: $lavc_version
+Requires: $pkg_requires libavutil = $lavu_version
+Conflicts:
+Libs: \${libdir}/${LIBPREF}avcodec${LIBSUF} $extralibs
+Cflags: -I\${includedir}
+EOF
+
+# libavformat.pc
+cat <<EOF >libavformat.pc
+prefix=$PREFIX
+exec_prefix=\${prefix}
+libdir=\${exec_prefix}/lib
+includedir=\${prefix}/include
+
+Name: libavformat
+Description: FFmpeg container format library
+Version: $lavf_version
+Requires: $pkg_requires libavcodec = $lavc_version
+Conflicts:
+Libs: -L\${libdir} -lavformat $extralibs
+Cflags: -I\${includedir} -I\${includedir}/ffmpeg
+EOF
+
+cat <<EOF >libavformat-uninstalled.pc
+prefix=
+exec_prefix=
+libdir=\${pcfiledir}/libavformat
+includedir=\${pcfiledir}/libavformat
+
+Name: libavformat
+Description: FFmpeg container format library
+Version: $lavf_version
+Requires: $pkg_requires libavcodec = $lavc_version
+Conflicts:
+Libs: \${libdir}/${LIBPREF}avformat${LIBSUF} $extralibs
+Cflags: -I\${includedir}
+EOF
+
+
+# libpostproc.pc
+cat <<EOF >libpostproc.pc
+prefix=$PREFIX
+exec_prefix=\${prefix}
+libdir=\${exec_prefix}/lib
+includedir=\${prefix}/include
+
+Name: libpostproc
+Description: FFmpeg post processing library
+Version: $lavc_version
+Requires:
+Conflicts:
+Libs: -L\${libdir} -lpostproc
+Cflags: -I\${includedir} -I\${includedir}/postproc
+EOF
+
+cat <<EOF >libpostproc-uninstalled.pc
+prefix=
+exec_prefix=
+libdir=\${pcfiledir}/libpostproc
+includedir=\${pcfiledir}/libpostproc
+
+Name: libpostproc
+Description: FFmpeg post processing library
+Version: $lavc_version
+Requires:
+Conflicts:
+Libs: \${libdir}/${LIBPREF}postproc${LIBSUF}
+Cflags: -I\${includedir}
+EOF
+
+if test "$swscaler" != "no"; then
+ sws_pc_libs="-L\${libdir} -lswscale"
+ sws_pc_uninstalled_libs="\${libdir}/${LIBPREF}swscale${LIBSUF}"
+ sws_pc_requires="$pkg_requires libavutil = $lavu_version"
+else
+ sws_pc_libs=""
+ sws_pc_uninstalled_libs=""
+ sws_pc_requires="$pkg_requires libavcodec = $lavc_version"
+fi
+# libswscale.pc
+cat <<EOF >libswscale.pc
+prefix=$PREFIX
+exec_prefix=\${prefix}
+libdir=\${exec_prefix}/lib
+includedir=\${prefix}/include
+
+Name: libswscale
+Description: FFmpeg image rescaling library
+Version: $sws_version
+Requires: $sws_pc_requires
+Conflicts:
+Libs: $sws_pc_libs
+Cflags: -I\${includedir} -I\${includedir}/swscale
+EOF
+
+cat <<EOF >libswscale-uninstalled.pc
+prefix=
+exec_prefix=
+libdir=\${pcfiledir}/libswscale
+includedir=\${pcfiledir}/libswscale
+
+Name: libswscale
+Description: FFmpeg image rescaling library
+Version: $sws_version
+Requires: $sws_pc_requires
+Conflicts:
+Libs: $sws_pc_uninstalled_libs
+Cflags: -I\${includedir}
+EOF